<div class="container-fluid">
  <div class="box">
    <div class="box-header with-border">
      <h3 class="box-title">RENT OWNERS</h3>
      <span class="fa fa-pull-right">
        <input type="text"
               pInputText placeholder="Search Owner with name"
               [(ngModel)]="name">
        <button type="button"
                label="Search"
                class="btn btn-success btn-xs"
                (click)="searchData()">
            Search
          </button>
      </span>
      <hr>
      <div class="box-body">
        <p-table id="exportTable"
                 class="text-center"
                 [columns]="columnName"
                 [value]="(data$)"
                 [(selection)]="selectedItems"
                 [resizableColumns]="true"
                 [autoLayout]="true">

          <ng-template pTemplate="caption">
            List of Rent Owners
            :&nbsp;{{ totalRecords }}
            <button class="btn btn-info btn-xs fa-pull-right"
                    (click)="addNewOwner('Add', null)">
              Add New Owner
            </button>
          </ng-template>
          <ng-template pTemplate="header" let-columns>
            <tr>
              <th *ngFor="let col of columns" [pSortableColumn]="col.value">
                {{col.name}}
                <p-sortIcon [field]="col.value"></p-sortIcon>
              </th>
            </tr>
          </ng-template>

          <ng-template pTemplate="body" let-list let-i="rowIndex">
            <tr [ngStyle]="{'background-color':i%2 === 0 ? '#fafafa' : '#e9ecef'}">
              <td>{{ i + 1 + itemsPerPage * page }}</td>
              <td>{{list.createdDate | date:'MMM d, y, h:mm:ss a'}}</td>
              <td>{{list.name}}</td>
              <td style="overflow-wrap: anywhere">{{list.address}}</td>
              <td>{{ list.contactNumber}}</td>
              <td>{{list.panNumber }}</td>
              <td>{{list.paymentTo }}</td>
              <td>{{list.status}}</td>
              <td>
                <a (click)="addNewOwner('Edit', list)">
                  <button class="btn btn-success btn-xs">
                    Edit <i class="pi pi-check-square"></i>
                  </button>
                </a>
                <a [routerLink]="['/rent/owner', list.rentOwnerId ]"
                   name={{list.rentOwnerId}}>
                  <button class="btn btn-info btn-xs">
                    View <i class="pi pi-eye"></i>
                  </button>
                </a>
              </td>
            </tr>
          </ng-template>
        </p-table>
        <p-paginator
          [rows]="itemsPerPage"
          [totalRecords]="totalRecords"
          pageLinkSize="3"
          [rowsPerPageOptions]="rowsPerPageOptions"
          (onPageChange)="paginate($event)">
        </p-paginator>
      </div>
      <div class="box-footer">
      </div>
    </div>
  </div>
</div>

<p-dialog [(visible)]="showAddOwnerForm"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '590px', height: 'auto'}">
  <p-header>
    Add New Owner
  </p-header>
  <form [formGroup]="addEditOwnerDetailForm">
    <div class="row">
      <div class="col-sm-6">
        <div class="form-group">
          <label for="name">Name<span class="required">*</span></label>
          <input type="text"
                 class="form-control"
                 id="name"
                 formControlName="name"
                 [ngClass]="{ 'is-invalid': submitted && f.name.errors }"
                 placeholder="Enter Owner Name"
                 required
          >
          <div *ngIf="submitted && f.name.errors" class="invalid-feedback">
            <div *ngIf="f.name.errors.required">Name is Required.</div>
          </div>
        </div>
        <div class="form-group">
          <label for="branchId">Branch<span class="required">*</span></label>
          <select id="branchId"
                  class="form-control"
                  formControlName="branchId"
                  [ngClass]="{ 'is-invalid': submitted && f.branchId.errors }"
                  name="branchId">
            <option *ngFor="let event of (branches); let i = index"
                    [ngValue]="(branches)[i].branchId"
            >{{(branches)[i].name }}</option>
          </select>
          <div *ngIf="submitted && f.branchId.errors" class="invalid-feedback">
            <div *ngIf="f.branchId.errors.required">Branch is Required.</div>
          </div>
        </div>

        <div class="form-group">
          <label for="accountNumber">Account Number<span class="required">*</span></label>
          <input type="text"
                 class="form-control"
                 id="accountNumber"
                 formControlName="accountNumber"
                 [ngClass]="{ 'is-invalid': submitted && f.accountNumber.errors }"
                 placeholder="Enter Owner's A/c"
                 required
          >
          <div *ngIf="submitted && f.accountNumber.errors" class="invalid-feedback">
            <div *ngIf="f.accountNumber.errors.required">Account Number is Required.</div>
          </div>
        </div>
        <div class="form-group">
          <label>Nature Of Payment <span class="required">*</span> </label>
          <select class="form-control"
                  formControlName="natureOfPayment"
                  [ngClass]="{ 'is-invalid': submitted && f.natureOfPayment.errors }"
                  name="natureOfPayment">
            <option *ngFor="let event of (natureOfPayments); let i = index"
                    [ngValue]="(natureOfPayments)[i].value"
            >{{(natureOfPayments)[i].key}}</option>
          </select>
          <div *ngIf="submitted && f.natureOfPayment.errors" class="invalid-feedback">
            <div *ngIf="f.natureOfPayment.errors.required">Nature of Payment is Required.</div>
          </div>
        </div>

      </div>
      <div class="col-sm-6">
        <div class="form-group">
          <label for="contactNumber">Contact Number<span class="required">*</span></label>
          <input type="text"
                 class="form-control"
                 id="contactNumber"
                 formControlName="contactNumber"
                 [ngClass]="{ 'is-invalid': submitted && f.contactNumber.errors }"
                 placeholder="Enter Owner's Contact Number"
                 required
          >
          <div *ngIf="submitted && f.contactNumber.errors" class="invalid-feedback">
            <div *ngIf="f.contactNumber.errors.required">Contact Number is Required.</div>
          </div>
        </div>

        <div class="form-group">
          <label for="panNumber">PAN Number<span class="required">*</span></label>
          <input type="text"
                 class="form-control"
                 id="panNumber"
                 formControlName="panNumber"
                 [ngClass]="{ 'is-invalid': submitted && f.panNumber.errors }"
                 placeholder="Enter Owner's PAN Number"
                 required
          >
          <div *ngIf="submitted && f.panNumber.errors" class="invalid-feedback">
            <div *ngIf="f.panNumber.errors.required">PAN Number is Required.</div>
          </div>
        </div>

        <div class="form-group">
          <label>Payment To <span class="required">*</span> </label>
          <select class="form-control"
                  formControlName="paymentTo"
                  [ngClass]="{ 'is-invalid': submitted && f.paymentTo.errors }"
                  name="natureOfPayment">
            <option *ngFor="let event of (paymentTo); let i = index"
                    [ngValue]="(paymentTo)[i].value"
            >{{(paymentTo)[i].key}}</option>
          </select>
          <div *ngIf="submitted && f.paymentTo.errors" class="invalid-feedback">
            <div *ngIf="f.paymentTo.errors.required">Payment to is Required.</div>
          </div>
        </div>

      </div>
    </div>

    <div class="form-group">
      <label for="address">Address <span class="required">*</span></label>
      <input type="text"
             class="form-control"
             id="address"
             formControlName="address"
             [ngClass]="{ 'is-invalid': submitted && f.address.errors }"
             placeholder="Enter Owner's Address"
             required
      >
      <div *ngIf="submitted && f.address.errors" class="invalid-feedback">
        <div *ngIf="f.address.errors.required">Address is Required.</div>
      </div>
    </div>

    <div class="form-group">
      <label for="remarks">Remarks<span class="required">*</span></label>
      <input type="text"
             id="remarks"
             formControlName="remarks"
             class="form-control"
             placeholder="Max length 50 Characters"
             [ngClass]="{ 'is-invalid': submitted && f.remarks.errors }"
             maxlength="50"
             required>
      <div *ngIf="submitted && f.remarks.errors" class="invalid-feedback">
        <div *ngIf="f.remarks.errors.required">Remarks is required</div>
      </div>
    </div>

    <div class="form-group">
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-success btn-xs btn-block" (click)="submitForm()">
            Submit
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-danger btn-xs btn-block" (click)="cancelSubmit()"> Cancel</button>
        </div>
      </div>
    </div>
  </form>
</p-dialog>
